ompi/mca/btl/gm/btl_gm.h File Reference.TH "ompi/mca/btl/gm/btl_gm.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/btl/gm/btl_gm.h \- 
.SH SYNOPSIS
.br
.PP
\fC#include <sys/types.h>\fP
.br
\fC#include <string.h>\fP
.br
\fC#include <gm.h>\fP
.br
\fC#include 'class/ompi_free_list.h'\fP
.br
\fC#include 'class/ompi_bitmap.h'\fP
.br
\fC#include 'opal/event/event.h'\fP
.br
\fC#include 'mca/pml/pml.h'\fP
.br
\fC#include 'mca/btl/btl.h'\fP
.br
\fC#include 'mca/btl/base/base.h'\fP
.br
\fC#include 'opal/util/output.h'\fP
.br
\fC#include 'mca/mpool/mpool.h'\fP
.br
\fC#include 'btl_gm_endpoint.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBGM_BUFFER_SIZE\fP   7"
.br
.ti -1c
.RI "#define \fBGM_BUFFER_LENGTH\fP   gm_max_length_for_size(GM_BUFFER_SIZE)"
.br
.ti -1c
.RI "#define \fBMCA_BTL_GM_ACQUIRE_TOKEN\fP(btl, frag)"
.br
.RI "\fIAcquire a send token - queue the fragment if none available. \fP"
.ti -1c
.RI "#define \fBMCA_BTL_GM_RETURN_TOKEN\fP(btl)"
.br
.RI "\fIReturn send token and dequeue and pending fragments. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBmca_btl_gm_component_t\fP \fBmca_btl_gm_component_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_btl_gm_module_t\fP \fBmca_btl_gm_module_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBmca_btl_gm_component_open\fP (void)"
.br
.RI "\fIRegister GM component parameters with the MCA framework. \fP"
.ti -1c
.RI "int \fBmca_btl_gm_component_close\fP (void)"
.br
.RI "\fIAny final cleanup before being unloaded. \fP"
.ti -1c
.RI "\fBmca_btl_base_module_t\fP ** \fBmca_btl_gm_component_init\fP (int *num_btl_modules, bool allow_multi_user_threads, bool have_hidden_threads)"
.br
.RI "\fIGM component initialization. \fP"
.ti -1c
.RI "int \fBmca_btl_gm_component_progress\fP (void)"
.br
.RI "\fIGM component progress. \fP"
.ti -1c
.RI "int \fBmca_btl_gm_finalize\fP (struct \fBmca_btl_base_module_t\fP *btl)"
.br
.RI "\fICleanup any resources held by the BTL. \fP"
.ti -1c
.RI "int \fBmca_btl_gm_add_procs\fP (struct \fBmca_btl_base_module_t\fP *btl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_btl_base_endpoint_t\fP **peers, ompi_bitmap_t *reachable)"
.br
.RI "\fIPML->BTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_btl_gm_del_procs\fP (struct \fBmca_btl_base_module_t\fP *btl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_btl_base_endpoint_t\fP **peers)"
.br
.RI "\fIPML->BTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_btl_gm_send\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *btl_peer, struct \fBmca_btl_base_descriptor_t\fP *descriptor, mca_btl_base_tag_t tag)"
.br
.RI "\fIInitiate an asynchronous send. \fP"
.ti -1c
.RI "int \fBmca_btl_gm_put\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *btl_peer, struct \fBmca_btl_base_descriptor_t\fP *decriptor)"
.br
.RI "\fIInitiate an asynchronous put. \fP"
.ti -1c
.RI "int \fBmca_btl_gm_get\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *btl_peer, struct \fBmca_btl_base_descriptor_t\fP *decriptor)"
.br
.RI "\fIInitiate an asynchronous get. \fP"
.ti -1c
.RI "int \fBmca_btl_gm_register\fP (struct \fBmca_btl_base_module_t\fP *btl, mca_btl_base_tag_t tag, \fBmca_btl_base_module_recv_cb_fn_t\fP cbfunc, void *cbdata)"
.br
.RI "\fIRegister a callback function that is called on receipt of a fragment. \fP"
.ti -1c
.RI "\fBmca_btl_base_descriptor_t\fP * \fBmca_btl_gm_alloc\fP (struct \fBmca_btl_base_module_t\fP *btl, size_t size)"
.br
.RI "\fIAllocate a descriptor with a segment of the requested size. \fP"
.ti -1c
.RI "int \fBmca_btl_gm_free\fP (struct \fBmca_btl_base_module_t\fP *btl, \fBmca_btl_base_descriptor_t\fP *des)"
.br
.RI "\fIReturn a segment allocated by this BTL. \fP"
.ti -1c
.RI "\fBmca_btl_base_descriptor_t\fP * \fBmca_btl_gm_prepare_src\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *peer, struct mca_mpool_base_registration_t *, struct ompi_convertor_t *convertor, size_t reserve, size_t *size)"
.br
.RI "\fIPrepare a descriptor for send/rdma using the supplied convertor. \fP"
.ti -1c
.RI "\fBmca_btl_base_descriptor_t\fP * \fBmca_btl_gm_prepare_dst\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *peer, struct mca_mpool_base_registration_t *, struct ompi_convertor_t *convertor, size_t reserve, size_t *size)"
.br
.RI "\fIPrepare a descriptor for send/rdma using the supplied convertor. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "\fBmca_btl_gm_component_t\fP \fBmca_btl_gm_component\fP"
.br
.ti -1c
.RI "\fBmca_btl_gm_module_t\fP \fBmca_btl_gm_module\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 

.SH "Define Documentation"
.PP 
.SS "#define MCA_BTL_GM_ACQUIRE_TOKEN(btl, frag)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                                            \
    /* queue the descriptor if there are no send tokens */                                      \
    if(OPAL_THREAD_ADD32(&gm_btl->gm_num_send_tokens, -1) < 0) {                                \
        OPAL_THREAD_LOCK(&gm_btl->gm_lock);                                                     \
        opal_list_append(&gm_btl->gm_pending, (opal_list_item_t*)frag);                         \
        OPAL_THREAD_UNLOCK(&gm_btl->gm_lock);                                                   \
        OPAL_THREAD_ADD32(&gm_btl->gm_num_send_tokens, 1);                                      \
        return OMPI_SUCCESS;                                                                    \
    }                                                                                           \
} while (0)                                                                                     \
.fi
Acquire a send token - queue the fragment if none available. 
.PP
.SS "#define MCA_BTL_GM_RETURN_TOKEN(btl)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                                            \
   OPAL_THREAD_ADD32( &btl->gm_num_send_tokens, 1 );                                            \
   if(opal_list_get_size(&btl->gm_pending)) {                                                   \
       mca_btl_gm_frag_t* frag;                                                                 \
       OPAL_THREAD_LOCK(&btl->gm_lock);                                                         \
       frag = (mca_btl_gm_frag_t*)opal_list_remove_first(&btl->gm_pending);                     \
       OPAL_THREAD_UNLOCK(&btl->gm_lock);                                                       \
       if(NULL != frag) {                                                                       \
           switch(frag->type) {                                                                 \
           case MCA_BTL_GM_SEND:                                                                \
               mca_btl_gm_send(&btl->super, frag->endpoint, &frag->base, frag->hdr->tag);       \
               break;                                                                           \
           case MCA_BTL_GM_PUT:                                                                 \
               mca_btl_gm_put(&btl->super, frag->endpoint, &frag->base);                        \
               break;                                                                           \
           case MCA_BTL_GM_GET:                                                                 \
               mca_btl_gm_get(&btl->super, frag->endpoint, &frag->base);                        \
               break;                                                                           \
           }                                                                                    \
       }                                                                                        \
    }                                                                                           \
} while (0)
.fi
Return send token and dequeue and pending fragments. 
.PP
.SH "Function Documentation"
.PP 
.SS "int mca_btl_gm_add_procs (struct \fBmca_btl_base_module_t\fP * btl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_btl_base_endpoint_t\fP ** peers, ompi_bitmap_t * reachable)"
.PP
PML->BTL notification of change in the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) 
.br
\fInprocs\fP (IN) Number of processes 
.br
\fIprocs\fP (IN) Set of processes 
.br
\fIpeers\fP (OUT) Set of (optional) peer addressing info. 
.br
\fIpeers\fP (IN/OUT) Set of processes that are reachable via this BTL. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure. 
.RE
.PP

.SS "\fBmca_btl_base_descriptor_t\fP* mca_btl_gm_alloc (struct \fBmca_btl_base_module_t\fP * btl, size_t size)"
.PP
Allocate a descriptor with a segment of the requested size. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIsize\fP (IN) Request segment size. 
.RE
.PP

.SS "\fBmca_btl_base_module_t\fP** mca_btl_gm_component_init (int * num_btl_modules, bool allow_multi_user_threads, bool have_hidden_threads)"
.PP
GM component initialization. 
.PP
\fBParameters:\fP
.RS 4
\fInum_btl_modules\fP (OUT) Number of BTLs returned in BTL array. 
.br
\fIallow_multi_user_threads\fP (OUT) Flag indicating wether BTL supports user threads (TRUE) 
.br
\fIhave_hidden_threads\fP (OUT) Flag indicating wether BTL uses threads (TRUE) 
.RE
.PP

.SS "int mca_btl_gm_del_procs (struct \fBmca_btl_base_module_t\fP * btl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_btl_base_endpoint_t\fP ** peers)"
.PP
PML->BTL notification of change in the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL instance 
.br
\fInproc\fP (IN) Number of processes. 
.br
\fIprocs\fP (IN) Set of processes. 
.br
\fIpeers\fP (IN) Set of peer data structures. 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if cleanup was successful 
.RE
.PP

.SS "int mca_btl_gm_finalize (struct \fBmca_btl_base_module_t\fP * btl)"
.PP
Cleanup any resources held by the BTL. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP BTL instance. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure. 
.RE
.PP

.SS "int mca_btl_gm_free (struct \fBmca_btl_base_module_t\fP * btl, \fBmca_btl_base_descriptor_t\fP * des)"
.PP
Return a segment allocated by this BTL. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIdescriptor\fP (IN) Allocated descriptor. 
.RE
.PP

.SS "int mca_btl_gm_get (struct \fBmca_btl_base_module_t\fP * btl, struct \fBmca_btl_base_endpoint_t\fP * btl_peer, struct \fBmca_btl_base_descriptor_t\fP * decriptor)"
.PP
Initiate an asynchronous get. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIendpoint\fP (IN) BTL addressing information 
.br
\fIdescriptor\fP (IN) Description of the data to be transferred 
.RE
.PP

.SS "\fBmca_btl_base_descriptor_t\fP* mca_btl_gm_prepare_dst (struct \fBmca_btl_base_module_t\fP * btl, struct \fBmca_btl_base_endpoint_t\fP * endpoint, struct mca_mpool_base_registration_t * registration, struct ompi_convertor_t * convertor, size_t reserve, size_t * size)"
.PP
Prepare a descriptor for send/rdma using the supplied convertor. 
.PP
If the convertor references data that is contigous, the descriptor may simply point to the user buffer. Otherwise, this routine is responsible for allocating buffer space and packing if required.
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIendpoint\fP (IN) BTL peer addressing 
.br
\fIconvertor\fP (IN) Data type convertor 
.br
\fIreserve\fP (IN) Additional bytes requested by upper layer to precede user data 
.br
\fIsize\fP (IN/OUT) Number of bytes to prepare (IN), number of bytes actually prepared (OUT) 
.RE
.PP

.SS "\fBmca_btl_base_descriptor_t\fP* mca_btl_gm_prepare_src (struct \fBmca_btl_base_module_t\fP * btl, struct \fBmca_btl_base_endpoint_t\fP * endpoint, struct mca_mpool_base_registration_t * registration, struct ompi_convertor_t * convertor, size_t reserve, size_t * size)"
.PP
Prepare a descriptor for send/rdma using the supplied convertor. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIpeer\fP (IN) BTL peer addressing 
.RE
.PP

.SS "int mca_btl_gm_put (struct \fBmca_btl_base_module_t\fP * btl, struct \fBmca_btl_base_endpoint_t\fP * btl_peer, struct \fBmca_btl_base_descriptor_t\fP * decriptor)"
.PP
Initiate an asynchronous put. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIendpoint\fP (IN) BTL addressing information 
.br
\fIdescriptor\fP (IN) Description of the data to be transferred 
.RE
.PP

.SS "int mca_btl_gm_register (struct \fBmca_btl_base_module_t\fP * btl, mca_btl_base_tag_t tag, \fBmca_btl_base_module_recv_cb_fn_t\fP cbfunc, void * cbdata)"
.PP
Register a callback function that is called on receipt of a fragment. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if registration was successful 
.RE
.PP

.SS "int mca_btl_gm_send (struct \fBmca_btl_base_module_t\fP * btl, struct \fBmca_btl_base_endpoint_t\fP * endpoint, struct \fBmca_btl_base_descriptor_t\fP * des, mca_btl_base_tag_t tag)"
.PP
Initiate an asynchronous send. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIendpoint\fP (IN) BTL addressing information 
.br
\fIdescriptor\fP (IN) Description of the data to be transfered 
.br
\fItag\fP (IN) The tag value used to notify the peer. 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
